<template>
  <div id="app">
    <section> 
<!-- loader component -->
      <div 
        v-if="loading"
      >
      </div>
      
<!-- content tag -->
      <div
        class="content" 
        v-else
      >
        <div v-html="this.createComponent('_SUFIX1')"> </div> 
        <div v-html="this.createComponent('_SUFIX2')"> </div> 
        <div v-html="this.createComponent('_SUFIX3')"> </div>  
        <div v-html="this.createComponent('_SUFIX4')"> </div> 
      </div>
  </section>
  </div>
</template>
<script>
export default {
    data: ()=> ({
      component_prefix: 'SYSTEMPREFIX1',
      loading: false,
      tags_obj: {
        "SYSTEMPREFIX1_SUFIX1": {
          "Value":`
            <input 
              type="text" 
              placeholder="test input"
            >
            </input>`,
          "Timestamp":"2020-12-16T11:53:26+01:00",
          "Unit":"","Description":"",
          "Datatype":"STRING",
          "MinValue":0,
          "MaxValue":0,
          "Device":"CYTIVA"
        },
        "SYSTEMPREFIX1_SUFIX2": {
          "Value":`<button>test</button>`,
          "Timestamp":"2020-12-16T11:53:26+01:00",
          "Unit":"",
          "Description":"",
          "Datatype":"STRING",
          "MinValue":0,
          "MaxValue":0,
          "Device":"CYTIVA"
        },
        "SYSTEMPREFIX1_SUFIX3": {
          "Value":`
            <a 
              href="https://www.google.com.ua/" 
              class="test-link" 
              target="_blank"
            > 
              google link
            </a>`,
          "Timestamp":"2020-12-16T11:53:26+01:00",
          "Unit":"",
          "Description":"",
          "Datatype":"STRING",
          "MinValue":0,
          "MaxValue":0,
          "Device":"CYTIVA"
        },
        "SYSTEMPREFIX1_SUFIX4": {
          "Value":`<div>test div</div>`,
          "Timestamp":"2020-12-16T11:53:26+01:00",
          "Unit":"",
          "Description":"",
          "Datatype":"STRING",
          "MinValue":0,
          "MaxValue":0,
          "Device":"CYTIVA"
        },
      }
    }),
    mounted(){
//  loading up-to-date data on page load
      this.getObjectsData()
    },
    methods: {
// a simple example of a method for updating data in an object
      async getObjectsData(){
        this.loading = true;
        // await axios.get(`${API_URL}/example_url/${component_prefix}`)
        // .then((response) => {
        //   this.tags_obj = response
        // })
        this.loading = false;
      },
// method for updating the component with tags selected by user
      createComponent(id){
        let component_id = this.component_prefix + id
        return this.tags_obj[component_id].Value;
      },
    }
}
</script>

<style>
  #app{
    min-height: 500px;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
  }

  .content{
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;    
  }
  .content * {
    margin-top: 5px;
  }
  .test-link{
    color: red;
  }
</style>
